src/Entity/Offer.php
<?php

namespace App\Entity;

use App\Repository\OfferRepository;
use Doctrine\ORM\Mapping as ORM;

/**
 * @ORM\Entity(repositoryClass=OfferRepository::class)
 */
class Offer
{
    /**
     * @ORM\Id
     * @ORM\GeneratedValue
     * @ORM\Column(type="integer")
     */
    private $id;

    /**
     * @ORM\Column(type="string", length=255)
     */
    private $title;

    /**
     * @ORM\Column(type="string", length=2047)
     */
    private $description;

    /**
     * @ORM\Column(type="string", length=255)
     */
    private $phone_number;

    /**
     * @ORM\Column(type="string", length=255)
     */
    private $post_code;

    /**
     * @ORM\Column(type="date")
     */
    private $Date;

    /**
     * @ORM\Column(type="string", length=255, nullable=true)
     */
    private $Image;

    /**
     * @ORM\ManyToOne(targetEntity=User::class, inversedBy="username")
     * @ORM\JoinColumn(nullable=false)
     */
    private $user;

    /**
     * @ORM\Column(type="string", length=255, nullable=true)
     */
    private $Price;

    public function getId(): ?int
    {
        return $this->id;
    }

    public function getTitle(): ?string
    {
        return $this->title;
    }

    public function setTitle(string $title): self
    {
        $this->title = $title;

        return $this;
    }

    public function getDescription(): ?string
    {
        return $this->description;
    }

    public function setDescription(string $description): self
    {
        $this->description = $description;

        return $this;
    }

    public function getPhoneNumber(): ?string
    {
        return $this->phone_number;
    }

    public function setPhoneNumber(string $phone_number): self
    {
        $this->phone_number = $phone_number;

        return $this;
    }

    public function getPostCode(): ?string
    {
        return $this->post_code;
    }

    public function setPostCode(string $post_code): self
    {
        $this->post_code = $post_code;

        return $this;
    }

    public function getDate(): ?\DateTimeInterface
    {
        return $this->Date;
    }

    public function setDate(\DateTimeInterface $Date): self
    {
        $this->Date = $Date;

        return $this;
    }

    public function getImage(): ?string
    {
        return $this->Image;
    }

    public function setImage(?string $Image): self
    {
        $this->Image = $Image;

        return $this;
    }

    public function getUser(): ?User
    {
        return $this->user;
    }

    public function setUser(?User $user): self
    {
        $this->user = $user;

        return $this;
    }

    public function getPrice(): ?string
    {
        return $this->Price;
    }

    public function setPrice(?string $Price): self
    {
        $this->Price = $Price;

        return $this;
    }
}

src/Controller/MainController.php
<?php

namespace App\Controller;

use Doctrine\ORM\EntityManagerInterface;
use APP\Repository\OfferRepository;
use App\Entity\Offer;
use App\Entity\User;
use App\Form\CreateOfferFormType;
use Knp\Component\Pager\PaginatorInterface;
use Symfony\Bundle\FrameworkBundle\Controller\AbstractController;
use Symfony\Component\HttpFoundation\RedirectResponse;
use Symfony\Component\Routing\Generator\UrlGeneratorInterface;
use Symfony\Component\HttpFoundation\Request;
use Symfony\Component\HttpFoundation\Response;
use Symfony\Component\Routing\Annotation\Route;

class MainController extends AbstractController
{


    public function __construct(UrlGeneratorInterface $urlGenerator)
    {
        $this->urlGenerator = $urlGenerator;
    }
    /**
     * @Route("/", name="homepage")
     */
    public function index(EntityManagerInterface $em, PaginatorInterface $paginator, Request $request): Response
    {
      $repository = $em->getRepository(Offer::class);

      $offers = $repository->findBy([],['id'=>'DESC']);
      if (!$offers) {
        return $this->render('main/index.html.twig', [
          'offers' => $offers,
          'controller_name' => 'MainController',

        ]);
      }
      // set an array of custom parameters


      $pagination = $paginator->paginate(
        $offers, // Requête contenant les données à paginer (ici nos articles)
        $request->query->getInt('page', 1), // Numéro de la page en cours, passé dans l'URL, 1 si aucune page
        10 // Nombre de résultats par page
      );
      $pagination->setCustomParameters([
        'align' => 'center', # center|right (for template: twitter_bootstrap_v4_pagination and foundation_v6_pagination)
        'size' => 'small', # small|large (for template: twitter_bootstrap_v4_pagination)
        'style' => 'bottom',
      ]);
      return $this->render('main/index.html.twig', [
        'offers' =>$offers,
        'pagination' => $pagination,
        'controller_name' => 'MainController',
      ]);

    }

    /**
     * @Route("/manage_offer", name="manage_offer")
     */
    public function manage_offer(EntityManagerInterface $em, PaginatorInterface $paginator, Request $request): Response
    {
      $user=$this->getUser();
      $repository = $this->getDoctrine()->getRepository(Offer::class);
      $offers = $repository->findBy(['user' => $user->getId()],['id'=>'DESC']);
      return $this->render('main/manage_offer.html.twig', [
          'offers' => $offers,
          'controller_name' => 'MainController',
      ]);
    }

      /**
       * @Route("/delete_offer/{id}", name="delete_offer")
       */
      public function delete(Offer $offer, EntityManagerInterface $entityManager): Response
      {
          $entityManager->remove($offer);
          $entityManager->flush();
  
          return new RedirectResponse($this->urlGenerator->generate('delete_success'));
        }

      /**
       * @Route("/manage_offer_show/{id}", name="manage_offer_show")
       */
      public function manageOfferShow($id): Response
      {
        $repository = $this->getDoctrine()->getRepository(Offer::class);
        $offer = $repository->findBy(['id' => $id])[0];
          return $this->render('main/manage_offer_show.html.twig', [
              'offer' => $offer,
              'controller_name' => 'MainController',
          ]);
      }

    /**
     * @Route("/create_offer", name="create_offer")
     */
    public function add(Request $request, ): Response
    {

        $Offer = new Offer();
        $form = $this->createForm(CreateOfferFormType::class, $Offer);

        $form->handleRequest($request);
        if ($form->isSubmitted() && $form->isValid()) {
            $Offer->setUser($this->getUSer());
            $Offer->setDate(new \DateTime());
            if (null !== $Offer->getImage()) {
                $file = $form->get('Image')->getData();
                $fileName = uniqid().'.'.$file->guessExtension();

                try {
                    $file->move(
                        $this->getParameter('images_directory'), // Le dossier dans le quel le fichier va etre charger
                      $fileName
                    );
                } catch (FileException $e) {
                    return new Response($e->getMessage());
                }

                $Offer->setImage($fileName);
            }
            $entityManager = $this->getDoctrine()->getManager();
            $entityManager->persist($Offer);
            $entityManager->flush();
            return new RedirectResponse($this->urlGenerator->generate('creation_success'));
        }

        return $this->render('main/create_offer.html.twig', [
            'controller_name' => 'MainController',
            'form' => $form->createView(),
        ]);
    }
    /**
     * @Route("/creation_success", name="creation_success")
     */
    public function CreationSuccess(): Response
    {
        return $this->render('main/creation_success.html.twig', [
            'controller_name' => 'MainController',
        ]);
    }

        /**
     * @Route("/delete_success", name="delete_success")
     */
    public function DeleteSuccess(): Response
    {
        return $this->render('main/delete_success.html.twig', [
            'controller_name' => 'MainController',
        ]);
    }

    /**
     * @Route("/offers/{id}", name="offer")
     */
    public function ShowOffer($id): Response
    {
      $repository = $this->getDoctrine()->getRepository(Offer::class);
      $offer = $repository->findBy(['id' => $id])[0];
        return $this->render('main/show.html.twig', [
            'offer' => $offer,
            'controller_name' => 'MainController',
        ]);
    }
    
    /**
     * @Route("/search", name="search")
     */
    public function Search(): Response
    {
      $keyword=$_GET['q'];
      $repository = $this->getDoctrine()->getRepository(Offer::class);
      $offers = $repository->findByKeyword($keyword);
        return $this->render('main/search.html.twig', [
            'offers' => $offers,
            'controller_name' => 'MainController',
        ]);

      }
}

templates/main/create_offer.html.twig
{% extends 'base.html.twig' %}

{% block title %}Creer une annonce{% endblock %}


{% block main %}
<h3 class="main-title"> Creer une annonce </h3>
{{ form_start(form) }}
    {{ form_row(form.title, {label: 'Titre',label_attr:{'class': 'form-label'}}) }}
    {{ form_row(form.description,{label:'Description',label_attr:{'class': 'form-label'}}) }}        
    {{ form_row(form.phone_number,{label:'Numero de téléphone',label_attr:{'class': 'form-label'}}) }}
    {{ form_row(form.post_code,{label:'Code Postal',label_attr:{'class': 'form-label'}}) }}
    {{ form_row(form.price,{label:'Prix',label_attr:{'class': 'form-label'}}) }}
    {{ form_row(form.Image,{label:'Image',label_attr:{'class': 'form-label'},attr:{'class': 'btn-image'}}) }}
    <button type="submit" class="btn btn-login btn-primary delete">Créer l'offre</button>
{{ form_end(form) }}
{% endblock %}

templates/main/creation_success.html.twig
{% extends 'base.html.twig' %}

{% block title %}Creer une annonce{% endblock %}


{% block main %}
<h1 class="main-title">L'annonce a bien été créée</h1>
<a class="text-decoration-none text-dark" href="{{ path('homepage')}}">Retour a l'accueil</a> <br>
<a class="text-decoration-none text-dark" href="{{ path('manage_offer')}}">Gerer ses annonces</a>
{% endblock %}

templates/main/delete_success.html.twig
{% extends 'base.html.twig' %}

{% block title %}Creer une annonce{% endblock %}


{% block main %}
<h1 class="main-title">L'annonce a bien été supprimée</h1>
<a class="text-decoration-none text-dark" href="{{ path('homepage')}}">Retour a l'accueil</a> <br>
<a class="text-decoration-none text-dark" href="{{ path('manage_offer')}}">Gerer ses annonces</a>
{% endblock %}

templates/main/index.html.twig
{% extends 'base.html.twig' %}

{% block title %}Accueil{% endblock %}

{% block main %}
  <h3 class="main-title mt-3">Bienvenue sur Click and Fit</h3>
  {% if app.user %}
  <p class="p-3"> Connecté en tant que <b>{{app.user.lastname}} {{app.user.Firstname}}</b></p>
  {% endif %}
  <p class="p-3"> Retrouvez nos dernieres annonces</p>
  {% if offers %}
    {% for offer in pagination %}
    <a class="card text-decoration-none text-dark" href="{{ path('offer' , {id:offer.id}) }}">
        <img class="Image" src="uploads/{{offer.image}}" alt="Card image cap">
        <p class="Title"> {{offer.title}}</p>
        <p class="Description d-none d-md-block"> Prix : {{offer.price}}€ <br><br>
        Description : {{offer.description |truncate(180,true," ... (Lire la suite)")}}</p>
        <p class="PostCode">Code postal : {{offer.PostCode}}</p>
        <p class="Phone">Contact : {{offer.PhoneNumber}}</p>
    </a>
    {% endfor %}
    <div class="paginator-style">{{ knp_pagination_render(pagination) }}</div>
  {% endif %}
  {% if not offers %}
  <div class="center p-3">
    <p> Aucune offre n'est disponible, creez en une en allant dans 
    <a class="text-dark text-decoration-none " href="{{ path ('create_offer')}}"> "Créer une offre"</a>
  </p>
  {% endif %}

{% endblock %}

templates/main/manage_offer.html.twig
{% extends 'base.html.twig' %}

{% block title %}Gerer ses annonces{% endblock %}

{% block main %}
  <h3 class="main-title">Gerer ses annonces</h3>
  {% for offer in offers %}
    <a class="card text-decoration-none text-dark" href="{{ path('manage_offer_show' , {id:offer.id}) }}">
      <img class="Image" src="uploads/{{offer.image}}" alt="Card image cap">
      <p class="Title"> {{offer.title}}</p>
      <p class="Description d-none d-md-block"> Prix : {{offer.price}}€ <br>
      Description : {{offer.description|truncate(180,true," ... (Lire la suite)")}}</p>
      <p class="PostCode">Code postal : {{offer.PostCode}}</p>
      <p class="Phone">Contact : {{offer.PhoneNumber}}</p>
    </a>
      <form action="{{ path('delete_offer', { 'id': offer.id }) }}" method="delete">
        <input type="hidden" name="_method" value="DELETE" />
        <button class="btn btn-danger btn-delete" type="submit">Supprimer l'annonce</button>
      </form>  
  {% endfor %}
{% endblock %}

templates/main/manage_offer_show.html.twig
{% extends 'base.html.twig' %}

{% block title %}{{offer.title}}{% endblock %}

{% block main %}
  <h3 class="main-title ">{{offer.title}}</h3>
  <img class="show-image" src="/uploads/{{offer.image}}" alt="Card image cap">
  <p>Description : {{offer.description}}</p>
  <p>Prix : {{offer.price}}€</p>
  <p>Code postal : {{offer.PostCode}}</p>
  <p>Contact : {{offer.PhoneNumber}}</p>
  <form action="{{ path('delete_offer', { 'id': offer.id }) }}" method="delete">
    <input type="hidden" name="_method" value="DELETE" />
    <button class="btn btn-danger btn-delete" type="submit">Supprimer l'annonce</button>
  </form>  
{% endblock %}

templates/main/search.html.twig
{% extends 'base.html.twig' %}

{% block title %}Accueil{% endblock %}

{% block main %}
  <h3 class="main-title">Bienvenue sur Click and Fit</h3>
  <span> Retrouvez nos dernieres annonces</span>
  {% for offer in offers %}
  <a class="card text-decoration-none text-dark" href="{{ path('offer' , {id:offer.id}) }}">
      <img class="Image" src="uploads/{{offer.image}}" alt="Card image cap">
      <p class="Title"> {{offer.title}}</p>
      <p class="Description d-none d-md-block"> Prix : {{offer.price}}€ <br>
      Description : {{offer.description}}</p>
      <p class="PostCode">Code postal : {{offer.PostCode}}</p>
      <p class="Phone">Contact : {{offer.PhoneNumber}}</p>
  </a>
  {% endfor %}
{% endblock %}

templates/main/show.html.twig
{% extends 'base.html.twig' %}

{% block title %}Offre{% endblock %}

{% block main %}
  <h3 class="main-title ">{{offer.title}}</h3>
  <img class="show-image" src="/uploads/{{offer.image}}" alt="Card image cap">
  <p>Description : {{offer.description}}</p>
  <p>Prix : {{offer.price}}€</p>
  <p>Code postal : {{offer.PostCode}}</p>
  <p>Contact : {{offer.PhoneNumber}}</p>
{% endblock %}